题目链接
思路
状态转移方程为 \(dp[i] = max(0, dp[i - 1], prices[i] - min)\),设置 dp[0] = 0
,所以在取最大值的过程中可以省略0,只需要写 dp[i] = Math.max(dp[i - 1], prices[i] - min)
。因为如果后面的都是负数的话,取最大值的结果就是 0,所以可以在取最大值的时候省略 0。
代码
dp 数组版
class Solution {
public int maxProfit(int[] prices) {
// dp[i] = max(0, dp[i - 1], prices[i] - min)
if(prices.length == 0){
return 0;
}
int min = prices[0];
int[] dp = new int[prices.length];
dp[0] = 0;
for(int i = 1; i < prices.length; i++){
dp[i] = Math.max(dp[i - 1], prices[i] - min);
min = Math.min(min, prices[i]);
}
return dp[prices.length - 1];
}
}
空间优化版
因为 dp[i]
只与 dp[i-1]
有关,所以可以设置一个单变量 pre
,不断维护更新 pre
,达到更新 dp[i]
的效果。
class Solution {
public int maxProfit(int[] prices) {
// dp[i] = max(0, dp[i - 1], prices[i] - min)
if(prices.length == 0){
return 0;
}
int min = prices[0];
int pre = 0;
for(int i = 1; i < prices.length; i++){
pre = Math.max(pre, prices[i] - min);
min = Math.min(min, prices[i]);
}
return pre;
}
}
标签:pre,min,int,max,121,DP,prices,LeetCode,dp
From: https://www.cnblogs.com/shixuanliu/p/17261941.html